#include <iostream>
#include <utility>
#include <string>

using namespace std;

#define MAXN 10000

int main()
{
   static int n, o, a, b, ab, krv[MAXN][4];
   pair<string, int> pacijenti[MAXN];

   cin >> n;
   cin >> o >> a >> b >> ab;
   for (int i = 0; i < n; i++)
      cin >> pacijenti[i].first >> pacijenti[i].second;

   for (int i = 0; i < n; i++)
   {
      if (pacijenti[i].first == "O")
      {
         while (pacijenti[i].second && o + 1)
         {
            o--;
            pacijenti[i].second--;
            krv[i][0]++;
         }
      }
      else if (pacijenti[i].first == "A")
      {
         while (pacijenti[i].second)
         {
            if (a)
            {
               a--;
               pacijenti[i].second--;
               krv[i][1]++;
            }
            else
            {
               o--;
               pacijenti[i].second--;
               krv[i][0]++;
            }
         }
      }
      else if (pacijenti[i].first == "B")
      {
         while (pacijenti[i].second)
         {
            if (b)
            {
               b--;
               pacijenti[i].second--;
               krv[i][2]++;
            }
            else
            {
               o--;
               pacijenti[i].second--;
               krv[i][0]++;
            }
         }
      }
      else if (pacijenti[i].first == "AB")
      {
         while (pacijenti[i].second)
         {
            if (ab)
            {
               ab--;
               pacijenti[i].second--;
               krv[i][3]++;
            }
            else if (a)
            {
               a--;
               pacijenti[i].second--;
               krv[i][1]++;
            }
            else if (b)
            {
               b--;
               pacijenti[i].second--;
               krv[i][2]++;
            }
         }
      }
      if (o < 0)
      {
         cout << "nemoguce\n";
         return 0;
      }
   }

   cout << "moguce\n";
   for (int i = 0; i < n; i++)
   {
      for (int j = 0; j < 4; j++)
      {
         cout << krv[i][j] << " ";
      }
      cout << "\n";
   }

   return 0;
}